#ifndef __ORAERROR_H_
#define __ORAERROR_H_

#include "ocicpp.h"

class OraError {
public:
	ErrorType errtype;	
	string message;

	sword status;
	sb4 errcode;
	OCIError *errhp;

	OraError(OCIError *err,sword status) {
		text *error;
		this->status=status;
		errhp=err;
		error=(text *)calloc(512,sizeof(text));
		(void) OCIErrorGet((dvoid *)errhp, (ub4) 1, (text *) NULL, &errcode, error, 512, OCI_HTYPE_ERROR);
		error[511]='\0';
		message.assign((char *)error);
		free(error);
		errtype=ORAERROR;
	}
	OraError(char *err,sword status) {
		errhp=(OCIError *) 0;
		this->status=status;
		message.assign(err);
		errtype=ORAERROR;
	}
	OraError(string &mess,ErrorType t): status(-1),errcode(-1),errhp(0) {
		message.assign(mess);
		errtype=t;
	}
	OraError(int err): status(-1),errcode(-1),errhp(0) {
		errtype=OCICPPERROR;
		if(err==CELL_NULL) {
			message="OCICPP Error: Requested cell is null";
		} else if(err==CELL_NOT_EXISTS) {
			message="OCICPP Error: Requested cell is not exists";
		} else if(err==CELL_TYPE_UNSUPPORTED) {
			message="OCICPP Error: Requested cell is of unknown type";
		} else {
			message="OCICPP Error: unknown error";
		}
	}
		
	~OraError() {
	}
};

#endif