#include <ocicpp.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <string>
#include <iostream.h>
using namespace std;

void printHead(Cursor *);
void printRow(Cursor *);

int main(int argv,char **argc) {
	db::init();
	Cursor *cur=0;
	Connection *con=0;
	string cell;
	string tns,user,passwd;
	string sql;
	while(1) {
		cout<<">";
		getline(cin,sql);
		try {
			if(sql=="connect") {
				cout << "connect string:";
				getline(cin,tns);
				cout<<"user:";
				getline(cin,user);
				cout<<"password:";
				getline(cin,passwd);
				cout<<"Connecting..."<<endl;
				delete con;
				con=db::connect(tns.c_str(),user.c_str(),passwd.c_str());
				cout<<"connected."<<endl;
			} else if(sql=="transStart") {
				con->transStart();
			} else if(sql=="transCommit") {
				con->transCommit();
			} else if(sql=="transRollback") {
				con->transRollback();
			} else if(sql=="version") {
				version();
			} else if(sql=="exit") {
				//delete cur;
				delete con;
				exit(0);
			} else if(sql=="test_hash_cap") {
				if(con) {
					cout << "sql:";
					getline(cin,sql);
					cout << "enter '<' when finish playing"<<endl;
					cur=con->execQuery(sql);
					printHead(cur);
					if(!cur->fetch()) break;
					while(1) {
						string field;
						cout<<"Field to print or '.' to next row:";
						cin>>field;
						if(field==".") {
							if(!cur->fetch()) break;
						} else if(field=="<") {
							break;	
						} else {
							try {
								cur->getStr(field,cell);
								cout<<cell<<endl;
							} catch(OraError *er) {
								if(er->errtype==OCICPPERROR) {
									cout<<er->message<<endl;
									continue;
								} else throw;
							}
						}
					}	
				}	
			} else if(con) {
				cur=con->execQuery(sql);
				printHead(cur);
				while(cur->fetch()) {
					printRow(cur);	
				}
				delete cur;
			}
		} catch(OraError *er) {
			cout << "Catch exception" <<endl;
			cout << er->message<<endl;
		}
	}
}	

void printHead(Cursor *cur) {
	for(int i=0;i<cur->getNCols();i++) {
		string attrName;
		cur->getColName(i,attrName);
		if(!i) cout<<"|";
		cout<<attrName<<"("<<cur->getColSize(i)<<")|";
	}
	cout << endl;
}

void printRow(Cursor *cur) {
	string cell;
	int nCols=cur->getNCols();
	for(int i=0;i<nCols;i++) {
		cur->getStr(i,cell);
		if(!i) cout<<"|";
		cout<<cell<<"|";
	}
	cout << endl;
}